unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, SQLDB, DB, SQLite3Conn, Forms, Controls, Graphics, Dialogs,
  StdCtrls, DBCtrls, DBGrids, RxDBGrid, sqlite3dyn, Math;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    DBGrid1: TDBGrid;
    dsInfo1: TDataSource;
    DBText1: TDBText;
    dsTest1: TDataSource;
    sql3Con1: TSQLite3Connection;
    qTest1: TSQLQuery;
    qInfo1: TSQLQuery;
    SQLTran1: TSQLTransaction;
    procedure Button1Click(Sender: TObject);
    procedure CreateDB;
    procedure FillDB;
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.frm}

{ TForm1 }

procedure TForm1.CreateDB;
//var
//  ThisMoment: double;
begin
       {$IFDEF UNIX}
        {$IFNDEF DARWIN}
          sqlite3dyn.SQLiteDefaultLibrary := './libsqlite3.so.0.8.6';
        {$ENDIF}
      {$ENDIF}

  {$IFDEF WINDOWS}
     sqlite3dyn.SQLiteDefaultLibrary := 'sqlite3.dll';
  {$ENDIF}

  //ThisMoment:=Now;
   //sql3Con1.DatabaseName := FormatDateTime('YYYYMMDD_hhnnss',ThisMoment)+'_test1.sqlite';
   Sql3Con1.DatabaseName:= ':memory:';

    try
      sql3Con1.Open;
      sqlTran1.Active := true;

      sql3Con1.ExecuteDirect('PRAGMA journal_mode = MEMORY');
      sql3Con1.ExecuteDirect('CREATE TABLE "test1"('+
      ' "id" Integer NOT NULL PRIMARY KEY AUTOINCREMENT,'+
      ' "rx" Real,'+
      ' "ry" Real,'+
      ' "rz" Real,'+
      ' "ix" Integer,'+
      ' "iy" Integer,'+
      ' "strx" Char(32));');
      sqlTran1.Commit;
     // ShowMessage('Table was created');
    except
      ShowMessage('Table was not created');
      exit;
    end;
end;

procedure TForm1.FillDB;
var
  i: integer;
begin
  Randomize;
  qTest1.Open;
  qTest1.First;
  for i:= 1 to  longint(RandomRange(1,1000)) do begin
    qTest1.Append;
    qTest1.FieldByName('rx').AsFloat:= random;
    qTest1.FieldByName('ry').AsFloat:= random;
    qTest1.FieldByName('rz').AsFloat:= random;
    qTest1.FieldByName('ix').AsInteger:= longInt( RandomRange(1,1000));
    qTest1.FieldByName('iy').AsInteger:= longInt( RandomRange(1,1000));
    qTest1.FieldByName('strx').AsString:= 'testing string';

    qTest1.Post;
    qTest1.ApplyUpdates;
  end;
  qTest1.Close;
  sqlTran1.Commit;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   CreateDB;
   FillDB;
   qTest1.Open;
   qInfo1.Open;
end;

end.

